         ORG $C000
         ORG $0400

:VERTICALLINE     = $C121
:HORIZONTALLINE   = $C118
:PUTSTRING        = $C148
:USESYSTEMFONT    = $C14B
:PUTDECIMAL       = $C184
:SETPATTERN       = $C139
:IRECTANGLE       = $C19F
:INVERTRECTANGLE  = $C12A
:AM               = $80
:COUNTER1         = $81
:COUNTER2         = $82
:AB               = $83
:X                = $84
:Y                = $85
:D1               = $86
:RASTER           = $88
:FLAG             = $89
:NZ2              = $10
:NZ1              = $12
:PUFFER           = $90
:SCREEN           = $2F
:DOICONS          = $C15A
:DSHIFTLEFT       = $C15D
:RECTANGLE        = $C124
:DOMENU           = $C151
:GOTOFIRSTMENU    = $C1BD
:DODLGBOX         = $C256
:COPYFSTRING      = $C265
:RENAMEFILE       = $C259
:ISMSEINREGION    = $C2B3
:SAVEFILE         = $C1ED
:GETFILE          = $C208
:MOVEDATA         = $C17E
:DELETEFILE       = $C238
:FINDFILE         = $C20B
:READFILE         = $C1FF



:START   JSR USESYSTEMFONT
         LDA #<ANAME
         STA NZ2
         LDA #>ANAME
         STA NZ2+1
         JSR INIT
         LDA #04
         STA AM
         LDA #00
         STA $84B5
         LDA #<TAB
         STA $02
         LDA #>TAB
         STA $03
         JSR DOICONS
         LDA #<HMENU
         STA $02
         LDA #>HMENU
         STA $03
         JSR DOMENU
         JSR WEG1
         JSR WEG2
         LDA #<145
         STA $08
         LDA #>145
         STA $09
         LDA #<319
         STA $0A
         LDA #>319
         STA $0B
         LDA #$00
         STA $18
         LDA #$FF
         JSR HORIZONTALLINE
         LDA #12
         STA $18
         LDA #$FF
         JSR HORIZONTALLINE
         LDA #$00
         STA $08
         LDA #12
         STA $09
         LDA #<319
         STA $0A
         LDA #>319
         STA $0B
         LDA #$FF
         JSR VERTICALLINE
         JSR SNAM
         JSR NOM
         LDA #00
         STA RASTER
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         RTS
:HMENU   B 00
         B 12
         W 00
         W 144
         B %00000011
         W DATEI
         B %10000000
         W MENU1
         W MUSTER
         B %10000000
         W MENU2
         W SPEZIAL
         B %10000000
         W MENU3
:DATEI   B "DATEI"
         B 00
:MUSTER  B "MUSTER"
         B 00
:SPEZIAL B "SPEZIAL"
         B 00
:MENU3   B 12
         B 40
         W 00
         W 144
         B %10000010
         W BEGR31
         B 00
         W ON
         W BEGR32
         B 00
         W OFF
:MENU2   B 12
         B 82
         W 00
         W 144
         B %10000101
         W BEGR21
         B 00
         W NEG
         W BEGR22
         B 128
         W SPIEGEL
         W BEGR23
         B 00
         W CLR
         W BEGR24
         B 00
         W NEXT
         W BEGR25
         B 00
         W PREVIOUS
:SPIEGEL B 12
         B 40
         W 00
         W 144
         B 130
         W BEGR221
         B 00
         W MIRRORX
         W BEGR222
         B 00
         W MIRRORY
:MENU1   B 12
         B 82
         W 00
         W 144
         B %10000101
         W BEGR11
         B 00
         W CLOSE
         W BEGR12
         B 00
         W AKTUELL
         W BEGR13
         B 00
         W RECOVER
         W BEGR14
         B 00
         W RENAME
         W BEGR15
         B 00
         W QUIT
:BEGR221 B "X"
         B 00
:BEGR222 B "Y"
         B 00
:BEGR31  B "RASTER AN"
         B $00
:BEGR32  B "RASTER AUS"
         B $00
:BEGR21  B "INVERTIEREN"
         B $00
:BEGR22  B "SPIEGELN"
         B $00
:BEGR23  B "LOESCHEN"
         B $00
:BEGR24  B "NAECHSTES MUSTER"
         B $00
:BEGR25  B "VORHERGEHENDES MUSTER"
         B $00
:BEGR11  B "SCHLIESSEN"
         B $00
:BEGR12  B "AKTUALISIEREN"
         B 00
:BEGR13  B "WIEDERHERSTELLEN"
         B $00
:BEGR14  B "UMBENENNEN"
         B $00
:BEGR15  B "VERLASSEN"
         B $00
:ON      JSR GOTOFIRSTMENU
         LDA #00
         STA RASTER
         JMP SHOWPAT
:OFF     JSR GOTOFIRSTMENU
         LDA #$FF
         STA RASTER
         JMP SHOWPAT

:NEG     JSR GOTOFIRSTMENU
         LDA AM
         JSR SETPATTERN
         LDX #00
         STX COUNTER1
:NEG1    LDY COUNTER1
         LDA ($22),Y
         EOR #$FF
         STA ($22),Y
         INC COUNTER1
         LDX COUNTER1
         CPX #08
         BNE NEG1
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         RTS
:CLR     JSR GOTOFIRSTMENU
         LDA AM
         JSR SETPATTERN
         LDX #$00
         STX COUNTER1
:DOCLR   LDY COUNTER1
         LDA #$00
         STA ($22),Y
         INC COUNTER1
         LDX COUNTER1
         CPX #08
         BNE DOCLR
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         RTS
:NEXT    JSR GOTOFIRSTMENU
         LDX AM
         CPX #31
         BNE NEXT1
         RTS
:NEXT1   INC AM
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         JSR WEG1
         JSR NOM
         RTS
:PREVIOUS
         JSR GOTOFIRSTMENU
         LDX AM
         CPX #00
         BNE PREV1
         RTS
:PREV1   DEC AM
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         JSR WEG1
         JSR NOM
         RTS
:MIRRORX JSR GOTOFIRSTMENU
         LDA AM
         JSR SETPATTERN
         LDX #00
         STX COUNTER1
:DOX1    LDY COUNTER1
         LDA ($22),Y
         STA AB
         LDX #00
         STX COUNTER2
:DOX2    LDY COUNTER1
         LDA AB
         ROL
         STA AB
         LDA PUFFER,Y
         ROR
         STA PUFFER,Y
         INC COUNTER2
         LDX COUNTER2
         CPX #08
         BNE DOX2
         INC COUNTER1
         LDX COUNTER1
         CPX #08
         BNE DOX1
         LDX #00
         STX COUNTER1
:DOX3    LDY COUNTER1
         LDA PUFFER,Y
         STA ($22),Y
         INC COUNTER1
         LDX COUNTER1
         CPX #08
         BNE DOX3
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         RTS

:MIRRORY JSR GOTOFIRSTMENU
         LDA AM
         JSR SETPATTERN
         LDX #00
         STX COUNTER1
:DOY1    LDY COUNTER1
         LDA ($22),Y
         STA PUFFER,Y
         INC COUNTER1
         LDX COUNTER1
         CPX #08
         BNE DOY1
         LDX #00
         STX COUNTER1
         LDX #07
         STX COUNTER2
:DOY2    LDY COUNTER1
         LDA PUFFER,Y
         LDY COUNTER2
         STA ($22),Y
         INC COUNTER1
         DEC COUNTER2
         LDX COUNTER1
         CPX #08
         BNE DOY2
         JSR SHOWPAT
         JSR FILL
         JSR SHOW
         RTS
:CLOSE   JSR GOTOFIRSTMENU
         JSR AKTUELL
         JMP START
:AKTUELL JSR GOTOFIRSTMENU
         LDA #<ANAME
         STA $02
         LDA #>ANAME
         STA $03
         JSR DELETEFILE
         JMP SAVE
:RECOVER JSR GOTOFIRSTMENU
         JSR OPEN
         JSR SHOWPAT
         JSR FILL
         RTS
:RENAME  JSR GOTOFIRSTMENU
         LDA #<NAME
         STA NZ1
         LDA #>NAME
         STA NZ1+1
         LDA #<ANAME
         STA NZ2
         LDA #>ANAME
         STA NZ2+1
         JSR COPYAN
         LDA #<BOX1
         STA $02
         LDA #>BOX1
         STA $03
         JSR DODLGBOX
         LDA $02
         CMP #$02
         BNE DR1
         JSR COPYNA
         RTS
:DR1     LDA #<NAME
         STA $02
         LDA #>NAME
         STA $03
         JSR DELETEFILE
         JSR SAVE
         JSR WEG2
         JSR SNAM
         RTS
:QUIT    JSR AKTUELL
         JMP $C22C
:INIT    JSR SCNCLR
:DOINIT  JSR CLRN1
         JSR CLRN2
         JSR MOVEPRG
         LDA #<BOX2
         STA $02
         LDA #>BOX2
         STA $03
         JSR DODLGBOX
         LDA $3C
         CMP #53
         BCC NEW
         CMP #83
         BCC OLD
         JMP $C22C
:OLD     LDA #<BOX3
         STA $02
         LDA #>BOX3
         STA $03
         LDA #<KLASS
         STA $16
         LDA #>KLASS
         STA $17
         LDA #<ANAME
         STA $0C
         LDA #>ANAME
         STA $0D
         LDA #05
         STA $10
         JSR DODLGBOX
         LDA $02
         CMP #$02
         BEQ INIT
         JMP OPEN
:NEW     LDA #<ANAME
         STA NZ2
         LDA #>ANAME
         STA NZ2+1
         JSR CLRN2
         LDA #00
         STA ANAME
         LDA #<BOX1
         STA $02
         LDA #>BOX1
         STA $03
         JSR DODLGBOX
         LDA $02
         CMP #$02
         BEQ INIT
         LDA #$00
         STA $16
:SAVE    LDA #<53248
         STA $02
         LDA #>53248
         STA $03
         LDA #<DATA
         STA $04
         LDA #>DATA
         STA $05
         LDA #<256
         STA $06
         LDA #>256
         STA $07
         JSR MOVEDATA
         LDA #<INFO
         STA $14
         LDA #>INFO
         STA $15
         JSR SAVEFILE
:OPEN    LDA #<ANAME
         STA $0E
         LDA #>ANAME
         STA $0F
         JSR FINDFILE
         LDA $8401
         STA $04
         LDA $8402
         STA $05
         LDA #<320
         STA $06
         LDA #>320
         STA $07
         LDA #<PRG
         STA $10
         LDA #>PRG
         STA $11
         JSR READFILE
         LDA #<DATA
         STA $02
         LDA #>DATA
         STA $03
         LDA #<53248
         STA $04
         LDA #>53248
         STA $05
         LDA #<256
         STA $06
         LDA #>256
         STA $07
         JSR MOVEDATA
         JSR SHOW
         RTS


:INFO    W ANAME
         B $03
         B $15
         B $BF
         B 255,255,255
         B 128,000,001
         B 128,000,001
         B 128,000,001
         B 155,109,177
         B 142,056,225
         B 159,125,241
         B 142,056,225
         B 155,109,177
         B 129,199,001
         B 131,239,129
         B 129,199,001
         B 155,109,177
         B 142,056,225
         B 159,125,241
         B 142,056,225
         B 155,109,177
         B 128,000,001
         B 128,000,001
         B 128,000,001
         B 255,255,255
         B $83
         B 05
         B 00
         W PRG
         W DATA+256
         W PRG
         B "MUSTER"
         B $00
         S 13
         B "MUSTEREDITOR V1.3"
         B $00
         S 2
         S 20
         S 23
:DT      B "DIESE APPLICATION"
         B " KOPIERT DAS MUSTER"
         B " IN DAS KERNAL"
         S 47


:TAB     B 03
         W 18
         B 18
         W ICON1
         B 02
         B 16
         B 08
         B 64
         W KLICK1
         W ICON2
         B 22
         B 16
         B 16
         B 64
         W KLICK2
         W ICON1
         B 12
         B 16
         B 08
         B 64
         W KLICK3
:ICON1   B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 4
         B 00
:ICON2   B 127
         B 00 
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 127
         B 00
         B 08
         B 00
:KLICK1  LDA $3A
         SEC
         SBC LINKS
         LSR
         LSR
         LSR
         STA X
         LDA $3C
         SEC
         SBC OBEN
         LSR
         LSR
         LSR
         STA Y
         LDA X
         STA $08
         LDA Y
         STA $06
         JSR INVERT
         LDA #01
         STA D1
         LDA #00
         STA D1+1
         LDX #D1
         LDA #07
         SEC
         SBC X
         TAY
         JSR DSHIFTLEFT
         LDY Y
         LDA ($22),Y
         EOR D1
         STA ($22),Y
         JSR FILL
         JSR SHOW
         RTS
:KLICK2  SEC
         LDA $3A
         SBC #176
         STA X
         LDA $3B
         SBC #00
         STA Y
         LSR Y
         ROR X
         LSR Y
         ROR X
         LSR Y
         ROR X
         LSR Y
         ROR X
         SEC
         LDA $3C
         SBC #16
         STA Y
         LSR Y
         LSR Y
         LSR Y
         LSR Y
         LDA Y
         ASL
         ASL
         ASL
         CLC
         ADC X
         STA AB
         LDA FLAG
         CMP #$FF
         BEQ CM 
         LDA AB
         CMP #$00
         BEQ EK2
         CMP #$01
         BEQ EK2
         CMP #$02
         BEQ EK2
         STA AM
         JSR SETPATTERN
         JSR FILL
         JSR SHOWPAT
         JSR WEG1
         JSR NOM
:EK2     RTS
:CM      LDA AM
         JSR SETPATTERN
         LDA $22
         STA NZ1
         LDA $23
         STA NZ1+1
         LDA AB
         STA AM
         JSR SETPATTERN
         LDA $22
         STA NZ2
         LDA $23
         STA NZ2+1
         LDY #$00
:CM1     LDA (NZ1),Y
         STA (NZ2),Y
         INY
         CPY #$08
         BNE CM1
         INC FLAG
         JSR SHOW
         JSR WEG1
         JSR NOM
         RTS
:KLICK3  LDA #$FF
         STA FLAG
         RTS

:SHOWPAT LDA RASTER
         BNE AUS
         LDA #<M1         ; LICK-USTER
         STA $22          ; LADEN
         LDA #>M1         ; UND
         STA $23          ; AKTIVIEREN
         JSR IRECTANGLE   ; UND ECHTECK
         B 16             ; LOESCHEN
         B 80             ;
         W 16             ;
         W 80             ;
         JMP OKPAT
:AUS     LDA #00
         JSR SETPATTERN
         JSR IRECTANGLE
         B 16
         B 80
         W 16
         W 80
:OKPAT   LDA AM           ; USTER
         JSR SETPATTERN   ; AKTIVIEREN
         LDX #$00         ; AEHLER 1
         STX COUNTER1     ; AUF #00
:GET     LDY COUNTER1     ; AEHLER HOLEN
         LDA ($22),Y      ; YTE DES USTERS HOLEN
         STA AB           ; UND SICHERN
         LDX #$00         ; AEHLER 2
         STX COUNTER2     ; AUF #00
:PRINT   LDA AB           ; YTE HOLEN
         CLC              ; ARRY LOESCHEN
:TEST    CMP #128         ; IT 7 ESETZT ?
         BMI WEITER       ; EIN !
:SET     PHA              ; KKU RETTEN
         LDA #$C0         ; EIDE ILDSCHIRME
         STA SCREEN       ; ANSPRECHEN
         LDA COUNTER2     ;  HOLEN
         STA $08          ; SICHERN
         LDA COUNTER1     ;  HOLEN
         STA $06          ; SICHERN
         JSR INVERT       ; NVERTIEREN
         PLA              ; KKU HOLEN
:WEITER  INC COUNTER2     ; AEHLER ERHOEHEN
         LDX COUNTER2     ; AEHLER HOLEN
         CPX #$08         ; CHON FERTIG ?
         BNE PRINT2       ; EIN
         INC COUNTER1     ; AEHLER ERHOEHEN
         LDX COUNTER1     ; AEHLER HOLEN
         CPX #$08
         BNE GET
         RTS
:PRINT2  ROL
         JMP TEST
:INVERT  LDA $06          ;  HOLEN
         ASL              ; OSITION
         ASL              ; AUSRECHNEN
         ASL              ;
         CLC              ; DDITION VORBEREITEN
         ADC OBEN         ; ADDIEREN
         STA $06          ; SICHERN
         CLC              ; DDITION VORBEREITEN
         ADC #07          ; ADDIEREN
         STA $07          ; UND SICHERN
         LDA $08          ;  HOLEN
         ASL              ; OSITION
         ASL              ; AUSRECHNEN
         ASL              ;
         CLC              ; DDITION VORBEREITEN
         ADC LINKS        ; ADDIEREN
         STA $08          ; SICHERN
         CLC              ; DDITION VORBEREITEN
         ADC #07          ; ADDIEREN
         STA $0A          ; UND SICHERN
         LDA #$00         ; IGH YTES
         STA $09          ; LOESCHEN
         STA $0B          ; UND SCHREIBEN
         JSR INVERTRECTANGLE
         RTS
:OBEN    B 16
:LINKS   B 16
:FILL    LDA AM
         JSR SETPATTERN
         JSR IRECTANGLE
         B 16
         B 80
         W 96
         W 160
         RTS
:SCNCLR  LDA #02          ; USTER #00
         JSR SETPATTERN   ; AKTIVIEREN
         JSR IRECTANGLE   ; ECHTECK
         B $00
         B 199
         W 00
         W 319
         RTS
:COPYAN  LDX #$00
:DOCOPY1 LDA ANAME,X
         STA NAME,X
         INX
         CPX #18
         BNE DOCOPY1
         RTS
:COPYNA  LDX #$00
:DOCOPY2 LDA NAME,X
         STA ANAME,X
         INX
         CPX #18
         BNE DOCOPY2
         RTS
:CLRN1   LDX #00
         LDA $00
:DOC1    STA ANAME,X
         INX
         CPX #18
         BNE DOC1
         RTS
:CLRN2   LDX #00
         LDA $00
:DOC2    STA NAME,X
         INX
         CPX #18
         BNE DOC2
         RTS
:SHOW    LDX #31
         STX COUNTER1
:SHOW1   LDA COUNTER1
         JSR SETPATTERN
         LDA COUNTER1
         LSR
         LSR
         LSR
         TAX
         LDA Y1,X
         STA $06
         LDA Y2,X
         STA $07
         LDA COUNTER1
         AND #$07
         ASL
         TAX
         LDA X1,X
         STA $08
         LDA X2,X
         STA $0A
         INX
         LDA X1,X
         STA $09
         LDA X2,X
         STA $0B
         JSR RECTANGLE
         DEC COUNTER1
         LDX COUNTER1
         CPX #$FF
         BNE SHOW1
         LDA AM
         JSR SETPATTERN
         RTS
:WEG1    LDA #$00
         JSR SETPATTERN
         JSR IRECTANGLE
         B 01
         B 11
         W 145
         W 199
         LDA AM
         JSR SETPATTERN
         RTS
:WEG2    LDA #$00
         JSR SETPATTERN
         JSR IRECTANGLE
         B 01
         B 11
         W 200
         W 318
         LDA AM
         JSR SETPATTERN
         RTS
:NOM     LDA #$00
         STA $03
         LDA AM
         STA $02
         LDA #09
         STA $05
         LDA #<160
         STA $18
         LDA #>160
         STA $19
         LDA #%11000000
         JSR PUTDECIMAL
         RTS
:SNAM    LDA #<ANAME
         STA $02
         LDA #>ANAME
         STA $03
         LDA #09
         STA $05
         LDA #<200
         STA $18
         LDA #>200
         STA $19
         JSR PUTSTRING
         RTS
:MOVEPRG LDA #<PRGQ
         STA $02
         LDA #>PRGQ
         STA $03
         LDA #<PRG
         STA $04
         LDA #>PRG
         STA $05
         LDA #<$28
         STA $06
         LDA #>$28
         STA $07
         JSR MOVEDATA
         LDA #$A9
         STA PRG
         RTS
:M1      B 00
         B 00
         B 00
         B 24
         B 24
         B 00
         B 00
         B 00
:BOX1    B $81
         B $0B
         B 08
         B 08
         W TEXT1
         B $0D
         B 08
         B 24
         B NZ2
         B 16
         B 02
         B 08
         B 40
         B 00
:BOX2    B $81
         B $0B
         B 08
         B 16
         W TEXT2
         B $0B
         B 08
         B 48
         W TEXT3
         B $0B
         B 08
         B 80
         W TEXT4
         B 05
         B 08
         B 04
         B 05
         B 08
         B 36
         B 05
         B 08
         B 68
         B 00
:BOX3    B $81
         B $10
         B $01
         B 04
         B 05
         B 16
         B 16
         B 02
         B 16
         B 40
         B 00


:TEXT1   B "BITTE NEUEN NAMEN EINGEBEN"
         B $00
:TEXT2   B "NEUES FILE"
         B $00
:TEXT3   B "ALTES FILE"
         B $00
:TEXT4   B "DESKTOP"
         B $00
:KLASS   B "MUSTER"
         B $00
:X1      W 176
         W 192
         W 208
         W 224
         W 240
         W 256
         W 272
         W 288
:X2      W 191
         W 207
         W 223
         W 239
         W 255
         W 271
         W 287
         W 303
:Y1      B 16
         B 32
         B 48
         B 64
:Y2      B 31
         B 47
         B 63
         B 79
:ANAME   S 17
:NAME    S 17

:PRGQ    LDA #<DATA
         STA $02
         LDA #>DATA
         STA $03
         LDA #<53248
         STA $04
         LDA #>53248
         STA $05
         LDA #<256
         STA $06
         LDA #>256
         STA $07
         JSR MOVEDATA
         LDX #$3E
         LDY #$C2
         STX $849B
         STY $849C
         RTS
         S 26

         ORG $5000

:PRG     S $30
:DATA















 